#!/bin/bash 
echo
if [ "$USER" = "root" ]; then
   if [ "$HOME" = "/root" ]; then
   echo "Please avoid running klang as root! "
   echo "Use sudo if needed."
   exit
   fi
echo -n "Please type system user for Klang (other than root):"
   read USER
   if [ "$USER" = "root" ]; then
    exit
   fi
fi

if [ "x$USER" = "x" ]; then
    echo "USER variable not set"
    exit
fi 

if [ -x "/opt/kde//doc/Klanguage-1.0.3b/klang.sql.gz" ]; then
    echo "Have klang.sql? - ok"
else
    echo "Could not find /opt/kde//doc/Klanguage-1.0.3b/klang.sql.gz"
    exit
fi

echo "Setting up Klang for user, $USER"

echo "Please enter"
echo -n " Database Name:"
read cdatabase
echo -n " Database UserName:"
read cuser
echo -n " Database Password:"
read cpwd

echo "1 - Creating conf file for current user $USER"
if [ "x$HOME" != "x" ]; then 
    
    if [ ! -r $HOME/.klang ]; then
	(cd $HOME;mkdir .klang)
    fi
    
    if [ ! -r $HOME/.klang/conf ]; then
	echo "$cdatabase" > $HOME/.klang/conf
	echo "$cuser" >> $HOME/.klang/conf
	echo "$cpwd" >> $HOME/.klang/conf
	echo " conf file created."
	echo
	chown -R $USER $HOME/.klang/
    fi
    
    if [ ! -r $ODBCINI ]; then
	echo "2- adding ODBCINI"
	echo " ODBCINI=$HOME/.odbcini" >> $HOME/.profile
#	cp /opt/kde//doc/klang-1.0.2b/ODBCINI-Sample $HOME/.odbcini
	cp /opt/kde//doc/Klanguage-1.0.3b/ODBCINI-Sample $HOME/.odbcini
	chown -R $USER $HOME/.odbcini
	chown -R $USER $HOME/.profile
	if [ "$cdatabase" != "klang" ]; then
	    echo "Warning! You have chosen a database name different from klang"
	    echo "You will have to modify .odbcini after installation"
	fi
	
    else
        echo "2 - skipping ODBCINI already set ODBCINI=$ODBCINI"
		if [ "$cdatabase" != "klang" ]; then
	    echo "Warning! You have chosen a database name different from klang"
	    echo "You might have to modify $ODBCINI after installation"
	fi
    fi
    
fi

echo "Setup for usage with MySQL y/n"
read ans
if [ "x$ans" != "y" ]; then
    echo "3- setting up Klang database "
    
    if [ x$cdatabase != "x" ]; then
#	echo " Please type, mysql root password (to create $cdatabase)"
#	mysqladmin -u root -p create $cdatabase
#	ret=$?
#	if [ $ret -ne 0 ]; then
#	    echo "Database creation failed?"
#	    exit
#	fi
#	echo " Database Created successfully"
	
        echo
	echo " INSERT INTO user (Host,User,Password) VALUES ('localhost','$cuser',PASSWORD('$cpwd'));" > priv.sql
	echo " create database $cdatabase;" >> priv.sql
	echo " grant all on $cdatabase.* to $cuser;" >> priv.sql
#	echo " grant all on $cdatabase.* to $cuser@localhost identified by Password '$cpwd';" >> priv.sql
	echo " FLUSH PRIVILEGES; " >> priv.sql
	cat priv.sql
	echo 
	echo "Please type, mysql root password (to set privileges)"
	cat priv.sql | mysql -u root -p mysql 
	ret=$?
	rm priv.sql
	if [ $ret -ne 0 ]; then
	    echo "Failed to set privileges"
	    exit
	fi
	echo "Privileges set successfully"
	echo
	echo "Importing Klang database, please wait..."
#	echo "Please type, password for $cuser (to import klang database)"
	cat /opt/kde//doc/Klanguage-1.0.3b/klang.sql.gz | gunzip | mysql -u $cuser -p$cpwd $cdatabase
	ret=$?
	if [ $ret -ne 0 ]; then
	    echo "Database import failed"
	    exit
	fi
	echo "Klang database imported successfully."
    fi
    
    ans=""
    echo "Store $USER as valid login user for klang application y/n"
    read ans
    if [ "x$ans" = "xy" ] ; then
     echo -n "Please enter password for $USER :"
     read KPWD
     echo -n  "Type of user (student/teacher/translator/administrator):"
     read TYPE
     echo -n "User Rights 0-99:"
     read LEVEL
     echo "INSERT INTO UserTable (Username,Password,Title,UserRights) Values('$USER',PASSWORD('$KPWD'),'$TYPE','$LEVEL');" > $USER.sql
     	cat $USER.sql | mysql -u $cuser -p$cpwd $cdatabase
	ret=$?
	if [ $ret -ne 0 ]; then
	    echo "Failed to add user $USER to klang database"
	    exit
	fi
	rm -Rf $USER.sql
	echo "Successfully added $USER to KLANG database."
    fi
fi
